//
//  SynthMix.m
//
//  Created by 成田 拓郎 on 10/05/30.
//  Copyright 2010 lovelyshark. All rights reserved.
//

#import "SynthMix.h"


@implementation SynthMix

@synthesize inputWaveObject3;
@synthesize inputWaveObject4;

//入力オブジェクトの初期化
//(入力オブジェクトを追加した場合、派生クラスでオーバーライドして、
// 入力オブジェクトのsynthBeginを呼び出す)
- (void) synthBeingInput
{
	[inputWaveObject3 synthBeing];
	[inputWaveObject4 synthBeing];
}

//このオブジェクトの演算関数
- (void) synthFunc:(int)length
{
	//出力バッファの準備
	float *waveout_src1  = (inputWaveObject) ? inputWaveObject.outputBuffer : [SynthObject dummyBuffer0];
	float *waveout_src2  = (inputControlObject) ? inputControlObject.outputBuffer : NULL;
	float *waveout_src3  = (inputWaveObject3) ? inputWaveObject3.outputBuffer : NULL;
	float *waveout_src4  = (inputWaveObject4) ? inputWaveObject4.outputBuffer : NULL;
	float *waveout_dest = outputBuffer;
	float *waveout_end  = waveout_dest + length;

	if (waveout_src2 == NULL) {
		//入力をそのまま出力
		while (waveout_dest != waveout_end) {
			(*waveout_dest) = (*waveout_src1);
			++waveout_dest;
			++waveout_src1;
		}
	}
	else if (waveout_src3 == NULL) {
		//2つの入力を加算して出力
		while (waveout_dest != waveout_end) {
			(*waveout_dest) = (*waveout_src1) + (*waveout_src2);
			++waveout_dest;
			++waveout_src1;
			++waveout_src2;
		}
	}
	else if (waveout_src4 == NULL) {
		//3つの入力を加算して出力
		while (waveout_dest != waveout_end) {
			(*waveout_dest) = (*waveout_src1) + (*waveout_src2) + (*waveout_src3);
			++waveout_dest;
			++waveout_src1;
			++waveout_src2;
			++waveout_src3;
		}
	}
	else {
		//4つの入力を加算して出力
		while (waveout_dest != waveout_end) {
			(*waveout_dest) = (*waveout_src1) + (*waveout_src2) + (*waveout_src3) + (*waveout_src4);
			++waveout_dest;
			++waveout_src1;
			++waveout_src2;
			++waveout_src3;
			++waveout_src4;
		}
	}
}

//入力オブジェクトの演算
//(入力オブジェクトを追加した場合、派生クラスでオーバーライドして、
// 入力オブジェクトのsynth:を呼び出す)
- (void)synthInput:(int)length
{
	[inputWaveObject3 synth:length];
	[inputWaveObject4 synth:length];
}

- (void) dealloc
{
	[inputWaveObject3 release];
	[inputWaveObject4 release];
	[super dealloc];
}

@end
