//
//  SynthVCA.m
//
//  Created by 成田 拓郎 on 10/05/01.
//  Copyright 2010 lovelyshark. All rights reserved.
//

#import "SynthVCA.h"


@implementation SynthVCA

@synthesize inputEGObject;

//入力オブジェクトの初期化
//(入力オブジェクトを追加した場合、派生クラスでオーバーライドして、
// 入力オブジェクトのsynthBeginを呼び出す)
- (void) synthBeingInput
{
	[inputEGObject synthBeing];
}

//このオブジェクトの演算関数
- (void) synthFunc:(int)length
{
	float *waveout_dest = outputBuffer;
	float *waveout_end  = waveout_dest + length;

	float *waveout_src = (inputWaveObject) ? inputWaveObject.outputBuffer : [SynthObject dummyBuffer0];
	float *waveout_eg  = (inputEGObject) ? inputEGObject.outputBuffer : [SynthObject dummyBuffer1];
	float *waveout_lfo = (inputControlObject) ? inputControlObject.outputBuffer : [SynthObject dummyBuffer0];

	float lfo_level1 = controlLevel * 0.5f;
	float lfo_level2 = 1.0f - fabsf(lfo_level1);
	while (waveout_dest != waveout_end) {
		*waveout_dest = (*waveout_src) * (*waveout_eg) * ((lfo_level1 * (*waveout_lfo)) + lfo_level2);
		++waveout_dest;
		++waveout_src;
		++waveout_eg;
		++waveout_lfo;
	}
}

//入力オブジェクトの演算
//(入力オブジェクトを追加した場合、派生クラスでオーバーライドして、
// 入力オブジェクトのsynth:を呼び出す)
- (void)synthInput:(int)length
{
	[inputEGObject synth:length];
}

- (id) init
{
	if (self = [super init])
	{
//		inputEGObject = nil;
	}
	
	return self;
}

- (void) dealloc
{
	[inputEGObject release];

	[super dealloc];
}


@end
